"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PeerconnectionModel = exports.InstantiableBrowserDeviceModel = exports.InstantiableCloudDeviceModel = exports.DeviceGroupModel = exports.ConcreteDeviceModel = exports.InstantiableDeviceOverviewModel = exports.DeviceOverviewModel = void 0;
const typeorm_1 = require("typeorm");
let DeviceOverviewModel = class DeviceOverviewModel {
};
__decorate([
    (0, typeorm_1.PrimaryGeneratedColumn)('uuid'),
    __metadata("design:type", String)
], DeviceOverviewModel.prototype, "uuid", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], DeviceOverviewModel.prototype, "name", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true }),
    __metadata("design:type", String)
], DeviceOverviewModel.prototype, "description", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], DeviceOverviewModel.prototype, "type", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true }),
    __metadata("design:type", String)
], DeviceOverviewModel.prototype, "owner", void 0);
__decorate([
    (0, typeorm_1.DeleteDateColumn)(),
    __metadata("design:type", Date)
], DeviceOverviewModel.prototype, "deletedAt", void 0);
DeviceOverviewModel = __decorate([
    (0, typeorm_1.Entity)({ name: 'Device' }),
    (0, typeorm_1.TableInheritance)({
        column: {
            type: 'varchar',
            name: 'type',
            enum: ['device', 'group', 'cloud instantiable', 'edge instantiable'],
        },
    })
], DeviceOverviewModel);
exports.DeviceOverviewModel = DeviceOverviewModel;
let InstantiableDeviceOverviewModel = class InstantiableDeviceOverviewModel extends DeviceOverviewModel {
};
__decorate([
    (0, typeorm_1.OneToMany)(() => ConcreteDeviceModel, (concreteDevice) => concreteDevice.instanceOf, {
        onDelete: 'CASCADE',
        cascade: true,
    }),
    __metadata("design:type", Array)
], InstantiableDeviceOverviewModel.prototype, "instances", void 0);
InstantiableDeviceOverviewModel = __decorate([
    (0, typeorm_1.ChildEntity)()
], InstantiableDeviceOverviewModel);
exports.InstantiableDeviceOverviewModel = InstantiableDeviceOverviewModel;
let ConcreteDeviceModel = class ConcreteDeviceModel extends DeviceOverviewModel {
};
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], ConcreteDeviceModel.prototype, "type", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", Boolean)
], ConcreteDeviceModel.prototype, "connected", void 0);
__decorate([
    (0, typeorm_1.Column)('simple-json'),
    __metadata("design:type", Array)
], ConcreteDeviceModel.prototype, "announcedAvailability", void 0);
__decorate([
    (0, typeorm_1.Column)('simple-json'),
    __metadata("design:type", Array)
], ConcreteDeviceModel.prototype, "availabilityRules", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], ConcreteDeviceModel.prototype, "experiment", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], ConcreteDeviceModel.prototype, "token", void 0);
__decorate([
    (0, typeorm_1.Column)('simple-json'),
    __metadata("design:type", Array)
], ConcreteDeviceModel.prototype, "services", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(() => InstantiableDeviceOverviewModel, (instantiableDevice) => instantiableDevice.instances),
    __metadata("design:type", InstantiableDeviceOverviewModel)
], ConcreteDeviceModel.prototype, "instanceOf", void 0);
ConcreteDeviceModel = __decorate([
    (0, typeorm_1.ChildEntity)('device')
], ConcreteDeviceModel);
exports.ConcreteDeviceModel = ConcreteDeviceModel;
let DeviceGroupModel = class DeviceGroupModel extends DeviceOverviewModel {
};
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], DeviceGroupModel.prototype, "type", void 0);
__decorate([
    (0, typeorm_1.Column)('simple-json'),
    __metadata("design:type", Array)
], DeviceGroupModel.prototype, "devices", void 0);
DeviceGroupModel = __decorate([
    (0, typeorm_1.ChildEntity)('group')
], DeviceGroupModel);
exports.DeviceGroupModel = DeviceGroupModel;
let InstantiableCloudDeviceModel = class InstantiableCloudDeviceModel extends InstantiableDeviceOverviewModel {
};
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], InstantiableCloudDeviceModel.prototype, "type", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], InstantiableCloudDeviceModel.prototype, "instantiateUrl", void 0);
__decorate([
    (0, typeorm_1.Column)('simple-json'),
    __metadata("design:type", Array)
], InstantiableCloudDeviceModel.prototype, "services", void 0);
InstantiableCloudDeviceModel = __decorate([
    (0, typeorm_1.ChildEntity)('cloud instantiable')
], InstantiableCloudDeviceModel);
exports.InstantiableCloudDeviceModel = InstantiableCloudDeviceModel;
let InstantiableBrowserDeviceModel = class InstantiableBrowserDeviceModel extends InstantiableDeviceOverviewModel {
};
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], InstantiableBrowserDeviceModel.prototype, "type", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], InstantiableBrowserDeviceModel.prototype, "codeUrl", void 0);
__decorate([
    (0, typeorm_1.Column)('simple-json'),
    __metadata("design:type", Array)
], InstantiableBrowserDeviceModel.prototype, "services", void 0);
InstantiableBrowserDeviceModel = __decorate([
    (0, typeorm_1.ChildEntity)('edge instantiable')
], InstantiableBrowserDeviceModel);
exports.InstantiableBrowserDeviceModel = InstantiableBrowserDeviceModel;
let PeerconnectionModel = class PeerconnectionModel {
};
__decorate([
    (0, typeorm_1.PrimaryGeneratedColumn)('uuid'),
    __metadata("design:type", String)
], PeerconnectionModel.prototype, "uuid", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], PeerconnectionModel.prototype, "type", void 0);
__decorate([
    (0, typeorm_1.Column)('varchar'),
    __metadata("design:type", String)
], PeerconnectionModel.prototype, "status", void 0);
__decorate([
    (0, typeorm_1.Column)('simple-json'),
    __metadata("design:type", Object)
], PeerconnectionModel.prototype, "deviceA", void 0);
__decorate([
    (0, typeorm_1.Column)('simple-json'),
    __metadata("design:type", Object)
], PeerconnectionModel.prototype, "deviceB", void 0);
__decorate([
    (0, typeorm_1.DeleteDateColumn)(),
    __metadata("design:type", Date)
], PeerconnectionModel.prototype, "deletedAt", void 0);
PeerconnectionModel = __decorate([
    (0, typeorm_1.Entity)({ name: 'Peerconnection' })
], PeerconnectionModel);
exports.PeerconnectionModel = PeerconnectionModel;
//# sourceMappingURL=model.js.map