"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.concreteDeviceRepository = exports.ConcreteDeviceRepository = void 0;
const model_1 = require("../../model");
const deviceOverview_1 = require("./deviceOverview");
const service_common_1 = require("@crosslab/service-common");
class ConcreteDeviceRepository extends service_common_1.AbstractRepository {
    constructor() {
        super('Concrete Device');
    }
    initialize(AppDataSource) {
        this.repository = AppDataSource.getRepository(model_1.ConcreteDeviceModel);
    }
    async create(data) {
        const model = await super.create(data);
        model.type = 'device';
        model.announcedAvailability = [];
        model.availabilityRules = [];
        model.connected = false;
        model.services = [];
        return model;
    }
    async write(model, data) {
        await deviceOverview_1.deviceOverviewRepository.write(model, data);
        if (data.experiment)
            model.experiment = data.experiment;
        if (data.services)
            model.services = data.services;
    }
    async format(model) {
        return {
            ...(await deviceOverview_1.deviceOverviewRepository.format(model)),
            type: 'device',
            announcedAvailability: model.announcedAvailability,
            connected: model.connected,
            experiment: model.experiment ?? undefined,
            services: model.services,
        };
    }
}
exports.ConcreteDeviceRepository = ConcreteDeviceRepository;
exports.concreteDeviceRepository = new ConcreteDeviceRepository();
//# sourceMappingURL=concreteDevice.js.map