"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.deviceOverviewRepository = void 0;
const urlFromId_1 = require("../../../methods/urlFromId");
const model_1 = require("../../model");
const service_common_1 = require("@crosslab/service-common");
class DeviceOverviewRepository extends service_common_1.AbstractRepository {
    constructor() {
        super('Device Overview');
    }
    initialize(AppDataSource) {
        this.repository = AppDataSource.getRepository(model_1.DeviceOverviewModel);
    }
    async write(model, data) {
        if (data.name)
            model.name = data.name;
        if (data.description)
            model.description = data.description;
    }
    async format(model) {
        return {
            url: (0, urlFromId_1.deviceUrlFromId)(model.uuid),
            type: model.type,
            name: model.name,
            description: model.description,
            owner: model.owner,
        };
    }
}
exports.deviceOverviewRepository = new DeviceOverviewRepository();
//# sourceMappingURL=deviceOverview.js.map