"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.instantiableBrowserDeviceRepository = exports.InstantiableBrowserDeviceRepository = void 0;
const model_1 = require("../../model");
const deviceOverview_1 = require("./deviceOverview");
const service_common_1 = require("@crosslab/service-common");
class InstantiableBrowserDeviceRepository extends service_common_1.AbstractRepository {
    constructor() {
        super('Instantiable Browser Device');
    }
    initialize(AppDataSource) {
        this.repository = AppDataSource.getRepository(model_1.InstantiableBrowserDeviceModel);
    }
    async create(data) {
        const model = await super.create(data);
        model.type = 'edge instantiable';
        return model;
    }
    async write(model, data) {
        await deviceOverview_1.deviceOverviewRepository.write(model, data);
        if (data.codeUrl)
            model.codeUrl = data.codeUrl;
        if (data.services)
            model.services = data.services;
    }
    async format(model) {
        return {
            ...(await deviceOverview_1.deviceOverviewRepository.format(model)),
            type: 'edge instantiable',
            codeUrl: model.codeUrl,
            services: model.services ?? undefined,
        };
    }
}
exports.InstantiableBrowserDeviceRepository = InstantiableBrowserDeviceRepository;
exports.instantiableBrowserDeviceRepository = new InstantiableBrowserDeviceRepository();
//# sourceMappingURL=instantiableBrowserDevice.js.map