"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.instantiableCloudDeviceRepository = exports.InstantiableCloudDeviceRepository = void 0;
const model_1 = require("../../model");
const deviceOverview_1 = require("./deviceOverview");
const service_common_1 = require("@crosslab/service-common");
class InstantiableCloudDeviceRepository extends service_common_1.AbstractRepository {
    constructor() {
        super('Instantiable Cloud Device');
    }
    initialize(AppDataSource) {
        this.repository = AppDataSource.getRepository(model_1.InstantiableCloudDeviceModel);
    }
    async create(data) {
        const model = await super.create(data);
        model.type = 'cloud instantiable';
        return model;
    }
    async write(model, data) {
        await deviceOverview_1.deviceOverviewRepository.write(model, data);
        if (data.instantiateUrl)
            model.instantiateUrl = data.instantiateUrl;
        if (data.services)
            model.services = data.services;
    }
    async format(model) {
        return {
            ...(await deviceOverview_1.deviceOverviewRepository.format(model)),
            type: 'cloud instantiable',
            instantiateUrl: model.instantiateUrl,
            services: model.services ?? undefined,
        };
    }
}
exports.InstantiableCloudDeviceRepository = InstantiableCloudDeviceRepository;
exports.instantiableCloudDeviceRepository = new InstantiableCloudDeviceRepository();
//# sourceMappingURL=instantiableCloudDevice.js.map