"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * This file was automatically generated by openapi-codegeneration.
 * DO NOT MODIFY IT BY HAND. Instead, modify the source OpenAPI file,
 * and run openapi-codegeneration to regenerate this file.
 */
const operations_1 = __importDefault(require("../operations"));
const requestValidation_1 = require("./requestValidation");
const types_1 = require("./types");
const express_1 = __importDefault(require("express"));
function routes(options) {
    const router = express_1.default.Router();
    async function handleSecurityRequirement(request, securityRequirement) {
        const userDataEntries = [];
        for (const method in securityRequirement) {
            const user = await options.security[method](request, securityRequirement[method]);
            if (!(0, types_1.isUserType)(user))
                throw new Error(`User resolved by method ${method} is not of type 'UserType'`);
            userDataEntries.push([method, user]);
        }
        return Object.fromEntries(userDataEntries);
    }
    router.get('/devices', async (req, res, next) => {
        const security = [
            {
                JWT: ['device', 'device:read', 'device:read:owned'],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error('Request could not be authenticated'));
            return;
        }
        try {
            if (!(0, requestValidation_1.validateGetDevicesInput)()) {
                throw new types_1.ValidationError('Request validation failed', requestValidation_1.validateGetDevicesInput.errors, 400);
            }
            const result = await operations_1.default.getDevices(userData);
            if (!(0, requestValidation_1.validateGetDevicesOutput)(result)) {
                throw new types_1.ValidationError('Response validation failed', requestValidation_1.validateGetDevicesOutput.errors, 500);
            }
            for (const headerName in result.headers) {
                const header = result.headers[headerName];
                if (header) {
                    res.setHeader(headerName, header);
                }
            }
            return res.status(result.status).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.post('/devices', async (req, res, next) => {
        const security = [
            {
                JWT: ['device', 'device:create'],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error('Request could not be authenticated'));
            return;
        }
        const parameters = {
            changedUrl: req.query['changedUrl'],
        };
        const body = req.body;
        try {
            if (!(0, requestValidation_1.validatePostDevicesInput)(parameters, body)) {
                throw new types_1.ValidationError('Request validation failed', requestValidation_1.validatePostDevicesInput.errors, 400);
            }
            const result = await operations_1.default.postDevices(parameters, body, userData);
            if (!(0, requestValidation_1.validatePostDevicesOutput)(result)) {
                throw new types_1.ValidationError('Response validation failed', requestValidation_1.validatePostDevicesOutput.errors, 500);
            }
            for (const headerName in result.headers) {
                const header = result.headers[headerName];
                if (header) {
                    res.setHeader(headerName, header);
                }
            }
            return res.status(result.status).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.get('/devices/:device_id', async (req, res, next) => {
        const security = [
            {
                JWT: ['device', 'device:read', 'device:read:owned'],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error('Request could not be authenticated'));
            return;
        }
        const parameters = {
            device_id: req.params['device_id'],
            flat_group: req.query['flat_group'] === 'true',
        };
        try {
            if (!(0, requestValidation_1.validateGetDevicesByDeviceIdInput)(parameters)) {
                throw new types_1.ValidationError('Request validation failed', requestValidation_1.validateGetDevicesByDeviceIdInput.errors, 400);
            }
            const result = await operations_1.default.getDevicesByDeviceId(parameters, userData);
            if (!(0, requestValidation_1.validateGetDevicesByDeviceIdOutput)(result)) {
                throw new types_1.ValidationError('Response validation failed', requestValidation_1.validateGetDevicesByDeviceIdOutput.errors, 500);
            }
            for (const headerName in result.headers) {
                const header = result.headers[headerName];
                if (header) {
                    res.setHeader(headerName, header);
                }
            }
            return res.status(result.status).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.patch('/devices/:device_id', async (req, res, next) => {
        const security = [
            {
                JWT: ['device', 'device:write', 'device:write:owned'],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error('Request could not be authenticated'));
            return;
        }
        const parameters = {
            device_id: req.params['device_id'],
            changedUrl: req.query['changedUrl'],
        };
        const body = req.body;
        try {
            if (!(0, requestValidation_1.validatePatchDevicesByDeviceIdInput)(parameters, body)) {
                throw new types_1.ValidationError('Request validation failed', requestValidation_1.validatePatchDevicesByDeviceIdInput.errors, 400);
            }
            const result = await operations_1.default.patchDevicesByDeviceId(parameters, body, userData);
            if (!(0, requestValidation_1.validatePatchDevicesByDeviceIdOutput)(result)) {
                throw new types_1.ValidationError('Response validation failed', requestValidation_1.validatePatchDevicesByDeviceIdOutput.errors, 500);
            }
            for (const headerName in result.headers) {
                const header = result.headers[headerName];
                if (header) {
                    res.setHeader(headerName, header);
                }
            }
            return res.status(result.status).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.delete('/devices/:device_id', async (req, res, next) => {
        const security = [
            {
                JWT: ['device', 'device:delete', 'device:delete:owned'],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error('Request could not be authenticated'));
            return;
        }
        const parameters = {
            device_id: req.params['device_id'],
        };
        try {
            if (!(0, requestValidation_1.validateDeleteDevicesByDeviceIdInput)(parameters)) {
                throw new types_1.ValidationError('Request validation failed', requestValidation_1.validateDeleteDevicesByDeviceIdInput.errors, 400);
            }
            const result = await operations_1.default.deleteDevicesByDeviceId(parameters, userData);
            if (!(0, requestValidation_1.validateDeleteDevicesByDeviceIdOutput)(result)) {
                throw new types_1.ValidationError('Response validation failed', requestValidation_1.validateDeleteDevicesByDeviceIdOutput.errors, 500);
            }
            for (const headerName in result.headers) {
                const header = result.headers[headerName];
                if (header) {
                    res.setHeader(headerName, header);
                }
            }
            return res.status(result.status).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.post('/devices/:device_id', async (req, res, next) => {
        const security = [
            {
                JWT: [
                    'device',
                    'device:instantiate',
                    'device:instantiate:owned',
                ],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error('Request could not be authenticated'));
            return;
        }
        const parameters = {
            device_id: req.params['device_id'],
            changedUrl: req.query['changedUrl'],
        };
        try {
            if (!(0, requestValidation_1.validatePostDevicesByDeviceIdInput)(parameters)) {
                throw new types_1.ValidationError('Request validation failed', requestValidation_1.validatePostDevicesByDeviceIdInput.errors, 400);
            }
            const result = await operations_1.default.postDevicesByDeviceId(parameters, userData);
            if (!(0, requestValidation_1.validatePostDevicesByDeviceIdOutput)(result)) {
                throw new types_1.ValidationError('Response validation failed', requestValidation_1.validatePostDevicesByDeviceIdOutput.errors, 500);
            }
            for (const headerName in result.headers) {
                const header = result.headers[headerName];
                if (header) {
                    res.setHeader(headerName, header);
                }
            }
            return res.status(result.status).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.post('/devices/:device_id/availability', async (req, res, next) => {
        const security = [
            {
                JWT: ['device', 'device:write', 'device:write:owned'],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error('Request could not be authenticated'));
            return;
        }
        const parameters = {
            device_id: req.params['device_id'],
        };
        const body = req.body;
        try {
            if (!(0, requestValidation_1.validatePostDevicesByDeviceIdAvailabilityInput)(parameters, body)) {
                throw new types_1.ValidationError('Request validation failed', requestValidation_1.validatePostDevicesByDeviceIdAvailabilityInput.errors, 400);
            }
            const result = await operations_1.default.postDevicesByDeviceIdAvailability(parameters, body, userData);
            if (!(0, requestValidation_1.validatePostDevicesByDeviceIdAvailabilityOutput)(result)) {
                throw new types_1.ValidationError('Response validation failed', requestValidation_1.validatePostDevicesByDeviceIdAvailabilityOutput.errors, 500);
            }
            for (const headerName in result.headers) {
                const header = result.headers[headerName];
                if (header) {
                    res.setHeader(headerName, header);
                }
            }
            return res.status(result.status).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.post('/devices/:device_id/websocket', async (req, res, next) => {
        const security = [
            {
                JWT: ['device', 'device:connect', 'device:connect:current'],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error('Request could not be authenticated'));
            return;
        }
        const parameters = {
            device_id: req.params['device_id'],
        };
        try {
            if (!(0, requestValidation_1.validatePostDevicesByDeviceIdWebsocketInput)(parameters)) {
                throw new types_1.ValidationError('Request validation failed', requestValidation_1.validatePostDevicesByDeviceIdWebsocketInput.errors, 400);
            }
            const result = await operations_1.default.postDevicesByDeviceIdWebsocket(parameters, userData);
            if (!(0, requestValidation_1.validatePostDevicesByDeviceIdWebsocketOutput)(result)) {
                throw new types_1.ValidationError('Response validation failed', requestValidation_1.validatePostDevicesByDeviceIdWebsocketOutput.errors, 500);
            }
            for (const headerName in result.headers) {
                const header = result.headers[headerName];
                if (header) {
                    res.setHeader(headerName, header);
                }
            }
            return res.status(result.status).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.post('/devices/:device_id/signaling', async (req, res, next) => {
        const security = [
            {
                JWT: ['device', 'device:signal'],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error('Request could not be authenticated'));
            return;
        }
        const parameters = {
            device_id: req.params['device_id'],
            peerconnection_url: req.query['peerconnection_url'],
        };
        const body = req.body;
        try {
            if (!(0, requestValidation_1.validatePostDevicesByDeviceIdSignalingInput)(parameters, body)) {
                throw new types_1.ValidationError('Request validation failed', requestValidation_1.validatePostDevicesByDeviceIdSignalingInput.errors, 400);
            }
            const result = await operations_1.default.postDevicesByDeviceIdSignaling(parameters, body, userData);
            if (!(0, requestValidation_1.validatePostDevicesByDeviceIdSignalingOutput)(result)) {
                throw new types_1.ValidationError('Response validation failed', requestValidation_1.validatePostDevicesByDeviceIdSignalingOutput.errors, 500);
            }
            for (const headerName in result.headers) {
                const header = result.headers[headerName];
                if (header) {
                    res.setHeader(headerName, header);
                }
            }
            return res.status(result.status).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.get('/peerconnections', async (req, res, next) => {
        const security = [
            {
                JWT: ['peerconnection', 'peerconnection:read'],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error('Request could not be authenticated'));
            return;
        }
        try {
            if (!(0, requestValidation_1.validateGetPeerconnectionsInput)()) {
                throw new types_1.ValidationError('Request validation failed', requestValidation_1.validateGetPeerconnectionsInput.errors, 400);
            }
            const result = await operations_1.default.getPeerconnections(userData);
            if (!(0, requestValidation_1.validateGetPeerconnectionsOutput)(result)) {
                throw new types_1.ValidationError('Response validation failed', requestValidation_1.validateGetPeerconnectionsOutput.errors, 500);
            }
            for (const headerName in result.headers) {
                const header = result.headers[headerName];
                if (header) {
                    res.setHeader(headerName, header);
                }
            }
            return res.status(result.status).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.post('/peerconnections', async (req, res, next) => {
        const security = [
            {
                JWT: ['peerconnection', 'peerconnection:create'],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error('Request could not be authenticated'));
            return;
        }
        const parameters = {
            closedUrl: req.query['closedUrl'],
            statusChangedUrl: req.query['statusChangedUrl'],
        };
        const body = req.body;
        try {
            if (!(0, requestValidation_1.validatePostPeerconnectionsInput)(parameters, body)) {
                throw new types_1.ValidationError('Request validation failed', requestValidation_1.validatePostPeerconnectionsInput.errors, 400);
            }
            const result = await operations_1.default.postPeerconnections(parameters, body, userData);
            if (!(0, requestValidation_1.validatePostPeerconnectionsOutput)(result)) {
                throw new types_1.ValidationError('Response validation failed', requestValidation_1.validatePostPeerconnectionsOutput.errors, 500);
            }
            for (const headerName in result.headers) {
                const header = result.headers[headerName];
                if (header) {
                    res.setHeader(headerName, header);
                }
            }
            return res.status(result.status).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.get('/peerconnections/:peerconnection_id', async (req, res, next) => {
        const security = [
            {
                JWT: ['peerconnection', 'peerconnection:read'],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error('Request could not be authenticated'));
            return;
        }
        const parameters = {
            peerconnection_id: req.params['peerconnection_id'],
        };
        try {
            if (!(0, requestValidation_1.validateGetPeerconnectionsByPeerconnectionIdInput)(parameters)) {
                throw new types_1.ValidationError('Request validation failed', requestValidation_1.validateGetPeerconnectionsByPeerconnectionIdInput.errors, 400);
            }
            const result = await operations_1.default.getPeerconnectionsByPeerconnectionId(parameters, userData);
            if (!(0, requestValidation_1.validateGetPeerconnectionsByPeerconnectionIdOutput)(result)) {
                throw new types_1.ValidationError('Response validation failed', requestValidation_1.validateGetPeerconnectionsByPeerconnectionIdOutput.errors, 500);
            }
            for (const headerName in result.headers) {
                const header = result.headers[headerName];
                if (header) {
                    res.setHeader(headerName, header);
                }
            }
            return res.status(result.status).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.delete('/peerconnections/:peerconnection_id', async (req, res, next) => {
        const security = [
            {
                JWT: ['peerconnection', 'peerconnection:delete'],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error('Request could not be authenticated'));
            return;
        }
        const parameters = {
            peerconnection_id: req.params['peerconnection_id'],
        };
        try {
            if (!(0, requestValidation_1.validateDeletePeerconnectionsByPeerconnectionIdInput)(parameters)) {
                throw new types_1.ValidationError('Request validation failed', requestValidation_1.validateDeletePeerconnectionsByPeerconnectionIdInput.errors, 400);
            }
            const result = await operations_1.default.deletePeerconnectionsByPeerconnectionId(parameters, userData);
            if (!(0, requestValidation_1.validateDeletePeerconnectionsByPeerconnectionIdOutput)(result)) {
                throw new types_1.ValidationError('Response validation failed', requestValidation_1.validateDeletePeerconnectionsByPeerconnectionIdOutput.errors, 500);
            }
            for (const headerName in result.headers) {
                const header = result.headers[headerName];
                if (header) {
                    res.setHeader(headerName, header);
                }
            }
            return res.status(result.status).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.patch('/peerconnections/:peerconnection_id/device_status', async (req, res, next) => {
        const security = [
            {
                JWT: ['peerconnection', 'peerconnection:read'],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error('Request could not be authenticated'));
            return;
        }
        const parameters = {
            peerconnection_id: req.params['peerconnection_id'],
            device_url: req.query['device_url'],
        };
        const body = req.body;
        try {
            if (!(0, requestValidation_1.validatePatchPeerconnectionsByPeerconnectionIdDeviceStatusInput)(parameters, body)) {
                throw new types_1.ValidationError('Request validation failed', requestValidation_1.validatePatchPeerconnectionsByPeerconnectionIdDeviceStatusInput.errors, 400);
            }
            const result = await operations_1.default.patchPeerconnectionsByPeerconnectionIdDeviceStatus(parameters, body, userData);
            if (!(0, requestValidation_1.validatePatchPeerconnectionsByPeerconnectionIdDeviceStatusOutput)(result)) {
                throw new types_1.ValidationError('Response validation failed', requestValidation_1.validatePatchPeerconnectionsByPeerconnectionIdDeviceStatusOutput.errors, 500);
            }
            for (const headerName in result.headers) {
                const header = result.headers[headerName];
                if (header) {
                    res.setHeader(headerName, header);
                }
            }
            return res.status(result.status).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    return router;
}
exports.default = routes;
//# sourceMappingURL=routes.js.map