"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isPeerconnection = exports.isSignalingMessage = exports.isClosePeerconnectionMessage = exports.isCreatePeerconnectionMessage = exports.isCommandMessage = exports.isMessage = exports.isDevice = exports.isDeviceGroup = exports.isInstantiableBrowserDevice = exports.isConcreteDevice = exports.isInstantiableCloudDevice = exports.isDeviceOverview = exports.isConnectionStateChangedMessage = exports.isAuthenticationMessage = exports.isUserType = exports.ValidationError = exports.ErrorWithStatus = exports.isErrorResponse = exports.isSuccessResponse = void 0;
/**
 * This file was automatically generated by openapi-codegeneration.
 * DO NOT MODIFY IT BY HAND. Instead, modify the source OpenAPI file,
 * and run openapi-codegeneration to regenerate this file.
 */
const basicValidation_1 = require("./basicValidation");
function isSuccessResponse(response) {
    return response.status < 400;
}
exports.isSuccessResponse = isSuccessResponse;
function isErrorResponse(response) {
    return response.status >= 400;
}
exports.isErrorResponse = isErrorResponse;
class ErrorWithStatus extends Error {
    constructor(message, status) {
        super(message);
        this.status = status;
        this.name = 'ErrorWithStatus';
    }
}
exports.ErrorWithStatus = ErrorWithStatus;
class ValidationError extends ErrorWithStatus {
    constructor(message, errors, status) {
        super(message, status);
        this.name = 'ValidationError';
        this.errors = errors;
    }
}
exports.ValidationError = ValidationError;
function isUserType(obj, type = 'all') {
    switch (type) {
        case 'request':
            return (0, basicValidation_1.validateUserTypeRequest)(obj);
        case 'response':
            return (0, basicValidation_1.validateUserTypeResponse)(obj);
        default:
            return (0, basicValidation_1.validateUserType)(obj);
    }
}
exports.isUserType = isUserType;
function isAuthenticationMessage(obj, type = 'all') {
    switch (type) {
        case 'request':
            return (0, basicValidation_1.validateAuthenticationMessageRequest)(obj);
        case 'response':
            return (0, basicValidation_1.validateAuthenticationMessageResponse)(obj);
        default:
            return (0, basicValidation_1.validateAuthenticationMessage)(obj);
    }
}
exports.isAuthenticationMessage = isAuthenticationMessage;
function isConnectionStateChangedMessage(obj, type = 'all') {
    switch (type) {
        case 'request':
            return (0, basicValidation_1.validateConnectionStateChangedMessageRequest)(obj);
        case 'response':
            return (0, basicValidation_1.validateConnectionStateChangedMessageResponse)(obj);
        default:
            return (0, basicValidation_1.validateConnectionStateChangedMessage)(obj);
    }
}
exports.isConnectionStateChangedMessage = isConnectionStateChangedMessage;
function isDeviceOverview(obj, type = 'all') {
    switch (type) {
        case 'request':
            return (0, basicValidation_1.validateDeviceOverviewRequest)(obj);
        case 'response':
            return (0, basicValidation_1.validateDeviceOverviewResponse)(obj);
        default:
            return (0, basicValidation_1.validateDeviceOverview)(obj);
    }
}
exports.isDeviceOverview = isDeviceOverview;
function isInstantiableCloudDevice(obj, type = 'all') {
    switch (type) {
        case 'request':
            return (0, basicValidation_1.validateInstantiableCloudDeviceRequest)(obj);
        case 'response':
            return (0, basicValidation_1.validateInstantiableCloudDeviceResponse)(obj);
        default:
            return (0, basicValidation_1.validateInstantiableCloudDevice)(obj);
    }
}
exports.isInstantiableCloudDevice = isInstantiableCloudDevice;
function isConcreteDevice(obj, type = 'all') {
    switch (type) {
        case 'request':
            return (0, basicValidation_1.validateConcreteDeviceRequest)(obj);
        case 'response':
            return (0, basicValidation_1.validateConcreteDeviceResponse)(obj);
        default:
            return (0, basicValidation_1.validateConcreteDevice)(obj);
    }
}
exports.isConcreteDevice = isConcreteDevice;
function isInstantiableBrowserDevice(obj, type = 'all') {
    switch (type) {
        case 'request':
            return (0, basicValidation_1.validateInstantiableBrowserDeviceRequest)(obj);
        case 'response':
            return (0, basicValidation_1.validateInstantiableBrowserDeviceResponse)(obj);
        default:
            return (0, basicValidation_1.validateInstantiableBrowserDevice)(obj);
    }
}
exports.isInstantiableBrowserDevice = isInstantiableBrowserDevice;
function isDeviceGroup(obj, type = 'all') {
    switch (type) {
        case 'request':
            return (0, basicValidation_1.validateDeviceGroupRequest)(obj);
        case 'response':
            return (0, basicValidation_1.validateDeviceGroupResponse)(obj);
        default:
            return (0, basicValidation_1.validateDeviceGroup)(obj);
    }
}
exports.isDeviceGroup = isDeviceGroup;
function isDevice(obj, type = 'all') {
    switch (type) {
        case 'request':
            return (0, basicValidation_1.validateDeviceRequest)(obj);
        case 'response':
            return (0, basicValidation_1.validateDeviceResponse)(obj);
        default:
            return (0, basicValidation_1.validateDevice)(obj);
    }
}
exports.isDevice = isDevice;
function isMessage(obj, type = 'all') {
    switch (type) {
        case 'request':
            return (0, basicValidation_1.validateMessageRequest)(obj);
        case 'response':
            return (0, basicValidation_1.validateMessageResponse)(obj);
        default:
            return (0, basicValidation_1.validateMessage)(obj);
    }
}
exports.isMessage = isMessage;
function isCommandMessage(obj, type = 'all') {
    switch (type) {
        case 'request':
            return (0, basicValidation_1.validateCommandMessageRequest)(obj);
        case 'response':
            return (0, basicValidation_1.validateCommandMessageResponse)(obj);
        default:
            return (0, basicValidation_1.validateCommandMessage)(obj);
    }
}
exports.isCommandMessage = isCommandMessage;
function isCreatePeerconnectionMessage(obj, type = 'all') {
    switch (type) {
        case 'request':
            return (0, basicValidation_1.validateCreatePeerconnectionMessageRequest)(obj);
        case 'response':
            return (0, basicValidation_1.validateCreatePeerconnectionMessageResponse)(obj);
        default:
            return (0, basicValidation_1.validateCreatePeerconnectionMessage)(obj);
    }
}
exports.isCreatePeerconnectionMessage = isCreatePeerconnectionMessage;
function isClosePeerconnectionMessage(obj, type = 'all') {
    switch (type) {
        case 'request':
            return (0, basicValidation_1.validateClosePeerconnectionMessageRequest)(obj);
        case 'response':
            return (0, basicValidation_1.validateClosePeerconnectionMessageResponse)(obj);
        default:
            return (0, basicValidation_1.validateClosePeerconnectionMessage)(obj);
    }
}
exports.isClosePeerconnectionMessage = isClosePeerconnectionMessage;
function isSignalingMessage(obj, type = 'all') {
    switch (type) {
        case 'request':
            return (0, basicValidation_1.validateSignalingMessageRequest)(obj);
        case 'response':
            return (0, basicValidation_1.validateSignalingMessageResponse)(obj);
        default:
            return (0, basicValidation_1.validateSignalingMessage)(obj);
    }
}
exports.isSignalingMessage = isSignalingMessage;
function isPeerconnection(obj, type = 'all') {
    switch (type) {
        case 'request':
            return (0, basicValidation_1.validatePeerconnectionRequest)(obj);
        case 'response':
            return (0, basicValidation_1.validatePeerconnectionResponse)(obj);
        default:
            return (0, basicValidation_1.validatePeerconnection)(obj);
    }
}
exports.isPeerconnection = isPeerconnection;
//# sourceMappingURL=types.js.map