"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.callbackHandling = void 0;
const event_1 = require("./event");
const service_common_1 = require("@crosslab/service-common");
__exportStar(require("../../methods/callbacks"), exports);
/**
 * This function adds the endpoint for incoming callbacks registered by the device service.
 * @param app The express application the callback endpoint should be added to.
 */
function callbackHandling(app) {
    app.post('/callbacks/device', async (req, res, next) => {
        try {
            const callback = req.body;
            if (typeof callback !== 'object')
                throw new service_common_1.MalformedBodyError('Body of callback is not an object', 400);
            if (callback === null)
                throw new service_common_1.MalformedBodyError('Body of callback is null', 400);
            if (!('callbackType' in callback)) {
                throw new service_common_1.MalformedBodyError("Callbacks require property 'callbackType'", 400);
            }
            if (typeof callback.callbackType !== 'string') {
                throw new service_common_1.MalformedBodyError("Property 'callbackType' needs to be of type string", 400);
            }
            switch (callback.callbackType) {
                case 'event':
                    return res.status(await (0, event_1.handleEventCallback)(callback)).send();
                default:
                    throw new service_common_1.InvalidValueError(`Callbacks of type '${req.body.callbackType}' are not supported`, 400);
            }
        }
        catch (error) {
            return next(error);
        }
    });
}
exports.callbackHandling = callbackHandling;
//# sourceMappingURL=index.js.map