"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.deleteDevicesByDeviceId = void 0;
const device_1 = require("../../../database/repositories/device");
/**
 * This function implements the functionality for handling DELETE requests on /devices/{device_id} endpoint.
 * @param parameters The parameters of the request.
 * @param _user The user submitting the request.
 * @throws {MissingEntityError} Thrown if device is not found in the database.
 */
const deleteDevicesByDeviceId = async (parameters, _user) => {
    console.log(`deleteDevicesByDeviceId called`);
    const deviceModel = await device_1.deviceRepository.findOneOrFail({
        where: { uuid: parameters.device_id },
    });
    await device_1.deviceRepository.remove(deviceModel);
    console.log(`deleteDevicesByDeviceId succeeded`);
    return {
        status: 204,
    };
};
exports.deleteDevicesByDeviceId = deleteDevicesByDeviceId;
//# sourceMappingURL=delete.js.map