"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getDevicesByDeviceId = void 0;
const device_1 = require("../../../database/repositories/device");
/**
 * This function implements the functionality for handling GET requests on /devices/{device_id} endpoint.
 * @param parameters The parameters of the request.
 * @param _user The user submitting the request.
 * @throws {MissingEntityError} Thrown if device is not found in the database.
 */
const getDevicesByDeviceId = async (parameters, _user) => {
    console.log(`getDevicesByDeviceId called`);
    const deviceModel = await device_1.deviceRepository.findOneOrFail({
        where: { uuid: parameters.device_id },
    });
    console.log(`getDevicesByDeviceId succeeded`);
    return {
        status: 200,
        body: await device_1.deviceRepository.format(deviceModel, {
            flatGroup: parameters.flat_group,
        }),
    };
};
exports.getDevicesByDeviceId = getDevicesByDeviceId;
//# sourceMappingURL=get.js.map