"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getDevices = void 0;
const device_1 = require("../../database/repositories/device");
const deviceOverview_1 = require("../../database/repositories/device/deviceOverview");
/**
 * This function implements the functionality for handling GET requests on /devices endpoint.
 * @param _user The user submitting the request.
 */
const getDevices = async (_user) => {
    console.log(`getDevices called`);
    const deviceModels = await device_1.deviceRepository.find();
    console.log(`getDevices succeeded`);
    return {
        status: 200,
        body: await Promise.all(deviceModels.map((device) => deviceOverview_1.deviceOverviewRepository.format(device))),
    };
};
exports.getDevices = getDevices;
//# sourceMappingURL=get.js.map