"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.postDevices = void 0;
const device_1 = require("../../database/repositories/device");
const callbacks_1 = require("../../methods/callbacks");
/**
 * This function implements the functionality for handling POST requests on /devices endpoint.
 * @param parameters The parameters of the request.
 * @param body The body of the request.
 * @param user The user submitting the request.
 */
const postDevices = async (parameters, body, user) => {
    console.log(`postDevices called`);
    const deviceModel = await device_1.deviceRepository.create(body);
    deviceModel.owner = user.JWT.url;
    await device_1.deviceRepository.save(deviceModel);
    if (parameters.changedUrl) {
        console.log(`registering changed-callback for device ${deviceModel.uuid} to '${parameters.changedUrl}'`);
        callbacks_1.changedCallbacks.set(deviceModel.uuid, [parameters.changedUrl]);
    }
    console.log(`postDevices succeeded`);
    return {
        status: 201,
        body: await device_1.deviceRepository.format(deviceModel),
    };
};
exports.postDevices = postDevices;
//# sourceMappingURL=post.js.map