"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getPeerconnectionsByPeerconnectionId = void 0;
const peerconnection_1 = require("../../../database/repositories/peerconnection");
/**
 * This function implements the functionality for handling GET requests on /peerconnections/{peerconnection_id} endpoint.
 * @param parameters The parameters of the request.
 * @param _user The user submitting the request.
 */
const getPeerconnectionsByPeerconnectionId = async (parameters, _user) => {
    console.log(`getPeerconnectionsByPeerconnectionId called`);
    const peerconnectionModel = await peerconnection_1.peerconnectionRepository.findOneOrFail({
        where: { uuid: parameters.peerconnection_id },
    });
    console.log(`getPeerconnectionsByPeerconnectionId succeeded`);
    return {
        status: 200,
        body: await peerconnection_1.peerconnectionRepository.format(peerconnectionModel),
    };
};
exports.getPeerconnectionsByPeerconnectionId = getPeerconnectionsByPeerconnectionId;
//# sourceMappingURL=get.js.map